#define FORWARD (-1)
#define INVERSE (+1)

#include "asptdefs.h"
#include <math.h>

void cplxFft64f(DT32S n, DT32S isgn, DT64F *a, DT32S *ip, DT64F *w);
void realFft64f(DT32S n, DT32S isgn, DT64F *a, DT32S *ip, DT64F *w);
void ddct64f(DT32S n, DT32S isgn, DT64F *a, DT32S *ip, DT64F *w);
void ddst64f(DT32S n, DT32S isgn, DT64F *a, DT32S *ip, DT64F *w);
void dfct64f(DT32S n, DT64F *a, DT64F *t, DT32S *ip, DT64F *w);
void dfst64f(DT32S n, DT64F *a, DT64F *t, DT32S *ip, DT64F *w);

void initCplxFft64f(DT32S n, DT32S *ip, DT64F *w);
void initRealFft64f(DT32S n, DT32S *ip, DT64F *w);
void initDdsct64f(DT32S n, DT32S *ip, DT64F *w);
void initDfsct64f(DT32S n, DT32S *ip, DT64F *w);

void makewt(DT32S nw, DT32S *ip, DT64F *w); 
void makect(DT32S nc, DT32S *ip, DT64F *c);

void makect64f(DT32S nc, DT32S *ip, DT64F *c);
void bitrv264f(DT32S n, DT32S *ip, DT64F *a);
void bitrv2conj64f(DT32S n, DT32S *ip, DT64F *a);
void cftfsub64f(DT32S n, DT64F *a, DT64F *w);
void cftbsub64f(DT32S n, DT64F *a, DT64F *w);
void cft1st64f(DT32S n, DT64F *a, DT64F *w);
void cftmdl64f(DT32S n, DT32S l, DT64F *a, DT64F *w);
void rftfsub64f(DT32S n, DT64F *a, DT32S nc, DT64F *c);
void rftbsub64f(DT32S n, DT64F *a, DT32S nc, DT64F *c);
void dctsub64f(DT32S n, DT64F *a, DT32S nc, DT64F *c);
void dstsub64f(DT32S n, DT64F *a, DT32S nc, DT64F *c);

