#define FORWARD (-1)
#define INVERSE (+1)

#include "asptdefs.h"
#include <math.h>

void cplxFft32f(DT32S n, DT32S isgn, DT32F *a, DT32S *ip, DT32F *w);
void realFft32f(DT32S n, DT32S isgn, DT32F *a, DT32S *ip, DT32F *w);
void ddct32f(DT32S n, DT32S isgn, DT32F *a, DT32S *ip, DT32F *w);
void ddst32f(DT32S n, DT32S isgn, DT32F *a, DT32S *ip, DT32F *w);
void dfct32f(DT32S n, DT32F *a, DT32F *t, DT32S *ip, DT32F *w);
void dfst32f(DT32S n, DT32F *a, DT32F *t, DT32S *ip, DT32F *w);

void initCplxFft32f(DT32S n, DT32S *ip, DT32F *w);
void initRealFft32f(DT32S n, DT32S *ip, DT32F *w);
void initDdsct32f(DT32S n, DT32S *ip, DT32F *w);
void initDfsct32f(DT32S n, DT32S *ip, DT32F *w);

void makewt(DT32S nw, DT32S *ip, DT32F *w); 
void makect(DT32S nc, DT32S *ip, DT32F *c);

void makect32f(DT32S nc, DT32S *ip, DT32F *c);
void bitrv232f(DT32S n, DT32S *ip, DT32F *a);
void bitrv2conj32f(DT32S n, DT32S *ip, DT32F *a);
void cftfsub32f(DT32S n, DT32F *a, DT32F *w);
void cftbsub32f(DT32S n, DT32F *a, DT32F *w);
void cft1st32f(DT32S n, DT32F *a, DT32F *w);
void cftmdl32f(DT32S n, DT32S l, DT32F *a, DT32F *w);
void rftfsub32f(DT32S n, DT32F *a, DT32S nc, DT32F *c);
void rftbsub32f(DT32S n, DT32F *a, DT32S nc, DT32F *c);
void dctsub32f(DT32S n, DT32F *a, DT32S nc, DT32F *c);
void dstsub32f(DT32S n, DT32F *a, DT32S nc, DT32F *c);

